Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
XPCOMUtils.defineLazyModuleGetter(this, "Downloads",
                                  "resource://gre/modules/Downloads.jsm");
XPCOMUtils.defineLazyModuleGetter(this, "DownloadIntegration",
                                  "resource://gre/modules/DownloadIntegration.jsm");
XPCOMUtils.defineLazyModuleGetter(this, "PluralForm",
                                  "resource://gre/modules/PluralForm.jsm");
XPCOMUtils.defineLazyModuleGetter(this, "PlacesUIUtils",
                                  "resource:///modules/PlacesUIUtils.jsm");
XPCOMUtils.defineLazyGetter(this, "TimerDmt", function() {
  let timer = {};
  Cu.import("resource://gre/modules/Timer.jsm", timer);
  return timer;
});

//  Components.utils.import("resource://gre/modules/Downloads.jsm");
//  Components.utils.import("resource://gre/modules/DownloadIntegration.jsm");
//  Components.utils.import("resource://gre/modules/PluralForm.jsm");
//  Components.utils.import("resource://gre/modules/Timer.jsm");
//  Components.utils.import("resource:///modules/PlacesUIUtils.jsm");

// This goes in a package to reduce name pollution.
const dmtBrowserOverlay = {
  dmtDownloadManagerURI: "chrome://downloadmgr/content/downloadmgrOverlay.xul",
  dmtPrefBranch: Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefBranch),
  dmtWindowMediator: Components.classes["@mozilla.org/appshell/window-mediator;1"]
                        .getService(Components.interfaces.nsIWindowMediator),
  dmtList: null,
  dmtView: null,

  ////////////////////////////////////////////////////////////////////////////////
  // Opens or closes download manager in the form the user selected (sidebar, tab,
  // or window).
  dmtToggleDownloadMgr: function DBO_dmtToggleDownloadMgr(open, close)
  {
//    var ww = Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
//                       .getService(Components.interfaces.nsIWindowWatcher);
//
//    if (window != ww.activeWindow) return 1;

    var winType = 0;
    try {
      winType = dmtBrowserOverlay.dmtPrefBranch.getIntPref("extensions.downloadmgr.windowType");
    } catch (e) {}


    try {
      if (winType == 1)
        document.getElementById("downloads-button").observes = "viewDmtSidebar";
      else
        document.getElementById("downloads-button").observes = "Tools:Downloads";
    } catch (e) {}

    if (winType == 1)
    {
      // Open Download Manager as a side bar
      if (open && close)
        toggleSidebar('viewDmtSidebar');
      else if (open)
        toggleSidebar('viewDmtSidebar',true);
    }
    else if (winType == 2)
    {
      // Open Download Manager as a tab
//      var thisBrowser = window.gBrowser.selectedTab;
      var thisBrowser = dmtBrowserOverlay.dmtWindowMediator.getMostRecentWindow(null).gBrowser;
      if (!thisBrowser)
        return 0;
      var oldTab = thisBrowser.selectedTab;
      var downTab = null;
//alert("dmtStart 1 " + open + ", " + close);

      // search tabs to see if one of them is the download tab.
      try {
        // Firefox 4.0 and later
        var numTabs = thisBrowser.visibleTabs.length;

        // The panorama tab grouping feature required addition of visibleTabs.
        for (var index = 0; index < numTabs; index++)
        {
          var uriSpec = thisBrowser.visibleTabs[index].linkedBrowser.currentURI.spec;

          if (uriSpec == dmtBrowserOverlay.dmtDownloadManagerURI)
          {
            downTab = thisBrowser.visibleTabs[index];
            break;
          }
        }
      } catch (e) {
      }

      if (downTab)
      {
        // Download tab is already open. Close it if it's the current tab or,
        // make it the current tab if it isn't.
        if (close)
        {
          if (downTab == oldTab)
            BrowserCloseTabOrWindow();
          else
            thisBrowser.selectedTab = downTab;
        }
      }
      else
      {
        // No download tab is open, create one.
        var downTab = thisBrowser.addTab(dmtBrowserOverlay.dmtDownloadManagerURI);

        try {
          if (gPrefService.getBoolPref("extensions.downloadmgr.openAsFirstTab"))
            thisBrowser.moveTabTo(downTab, 0);
        } catch (e) {}

        // Setting
        // When a download is active it might be nice to set:
        //    downTab.image = "chrome://global/skin/throbber/Throbber-small.gif"
        // Conditionally on the preference: "extensions.downloadmgr.tabBusyIcon".
        // Tricky part is handling multiple downloads (can't just start on
        // DMT-dl-start and end on DMT-dl-done).

        try {
          if (!gPrefService.getBoolPref("extensions.downloadmgr.loadTabInBackground"))
            thisBrowser.selectedTab = downTab;
          else
            thisBrowser.selectedTab = oldTab;
        } catch (e) {thisBrowser.selectedTab = downTab;}
      }
    }
    else
    {
      // Open Download Manager as a window
      if (open)
      {
        toOpenWindowByType('Download:Manager', dmtBrowserOverlay.dmtDownloadManagerURI,
                           'chrome, dialog=no, resizable');
      }
    }

    return 0;
  },

  ////////////////////////////////////////////////////////////////////////////////
  //
  dmtToggleSidebar: function DBO_dmtToggleSidebar(sidebarName)
  {
    var winType = 0;
    try {
      winType = dmtBrowserOverlay.dmtPrefBranch.getIntPref("extensions.downloadmgr.windowType");
    } catch (e) {}

    toggleSidebar(sidebarName);

    try {
      if (winType == 1)
        document.getElementById("downloads-button").observes = "viewDmtSidebar";
      else
        document.getElementById("downloads-button").observes = "Tools:Downloads";
    } catch (e) {}
  },

  ////////////////////////////////////////////////////////////////////////////////
  // Called when a shortcut key is used to close the download manager.
  dmtCloseDownloadMgr: function DBO_dmtCloseDownloadMgr()
  {
    // Try to close Download Manager in a side bar. There could be multiple
    // sidebars so try them all until a match is found. All sidebars have the same
    // fairly unique class that we can search on.
    var sidebarElements = document.getElementsByClassName("chromeclass-extrachrome");
    for (var i = 0; i < sidebarElements.length; i++)
    {
      var sidebarWindows = sidebarElements[i].getElementsByTagName("browser");
      for (var j = 0; j < sidebarWindows.length; j++)
      {
        if (sidebarWindows[j].contentWindow.location.href ==
            dmtBrowserOverlay.dmtDownloadManagerURI)
        {
          // Found an open DMT sidebar, close it.
          toggleSidebar('viewDmtSidebar', false);
          return;
        }
      }
    }

    // Not in a sidebar, try to close Download Manager in a tab
    // Check if current tab is the DM
    if (getWebNavigation().currentURI.spec == dmtBrowserOverlay.dmtDownloadManagerURI)
    {
      BrowserCloseTabOrWindow();
      return;
    }

    // Not in a sidebar or tab, close Download Manager in a separate window
    dmtWindowClose(0);
  },

  ////////////////////////////////////////////////////////////////////////////////
  // Called when a shortcut key is used to close the download manager.
  dmtEscapeDownloadMgr: function DBO_dmtEscapeDownloadMgr()
  {
    // Try to close Download Manager in a side bar. There could be multiple
    // sidebars so try them all until a match is found. All sidebars have the same
    // fairly unique class that we can search on.
    var sidebarElements = document.getElementsByClassName("chromeclass-extrachrome");
    for (var i = 0; i < sidebarElements.length; i++)
    {
      var sidebarWindows = sidebarElements[i].getElementsByTagName("browser");
      for (var j = 0; j < sidebarWindows.length; j++)
      {
        if (sidebarWindows[j].contentWindow.location.href ==
            dmtBrowserOverlay.dmtDownloadManagerURI)
        {
          // Found an open DMT sidebar, don't close it.
          return;
        }
      }
    }

    // Not in a sidebar, don't close Download Manager in a tab either.
    // Check if current tab is the DM
    if (getWebNavigation().currentURI.spec == dmtBrowserOverlay.dmtDownloadManagerURI)
    {
      return;
    }

    // Not in a sidebar or tab, close Download Manager in a separate window
    dmtWindowClose(0);
  },

  ////////////////////////////////////////////////////////////////////////////////
  // Handles cases when download manager is actually in a window.
  dmtWindowClose: function DBO_dmtWindowClose(count)
  {
    if (count > 5) return;
//    var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].
//                        getService();
//    var windowManagerInterface = windowManager.QueryInterface(
//                                         Components.interfaces.nsIWindowMediator);
//    var windowObj = windowManagerInterface.getMostRecentWindow("Download:Manager");
    var windowObj = dmtWindowMediator.getMostRecentWindow("Download:Manager");

    if (!windowObj)
    {
      // If no window can be found then try again after a delay. It may be that
      // the window hasn't had time to open before being asked to close. That
      // mainly happens for autoClose with short delays.
      TimerDmt.setTimeout(dmtBrowserOverlay.dmtWindowClose, 100, count + 1);
    }
    else
    {
      windowObj.close();
    }
  },

  ////////////////////////////////////////////////////////////////////////////////
  // Automatically close the download manager when downloads have completed.
  // This closes all of them, if multiple are open.
  dmtAutoClose: function DBO_dmtAutoClose()
  {
    // Close Download Manager in a side bar. There could be multiple sidebars so
    // try them all and close any match found. All sidebars have the same fairly
    // unique class that we can search on.
    var sidebarElements = document.getElementsByClassName("chromeclass-extrachrome");
    for (var i = 0; i < sidebarElements.length; i++)
    {
      var sidebarWindows = sidebarElements[i].getElementsByTagName("browser");
      for (var j = 0; j < sidebarWindows.length; j++)
      {
        if (sidebarWindows[j].contentWindow.location.href ==
            dmtBrowserOverlay.dmtDownloadManagerURI)
        {
          // Found an open DMT sidebar, close it.
          toggleSidebar('viewDmtSidebar', false);
        }
      }
    }

    // Close Download Manager in a tab
    {
//      var thisBrowser = window.gBrowser.selectedTab;
      var thisBrowser = dmtBrowserOverlay.dmtWindowMediator.getMostRecentWindow(null).gBrowser;
      if (thisBrowser)
      {
        var oldTab = thisBrowser.selectedTab;

        if (getWebNavigation().currentURI.spec == dmtBrowserOverlay.dmtDownloadManagerURI)
          oldTab = null;

        try {
          // Firefox 4.0 and later
          var numTabs = thisBrowser.visibleTabs.length;

          // The panorama tab grouping feature required addition of visibleTabs.
          for (var index = numTabs - 1; index >= 0; index--)
          {
            var uriSpec = thisBrowser.visibleTabs[index].linkedBrowser.currentURI.spec;

            if (uriSpec == dmtBrowserOverlay.dmtDownloadManagerURI)
            {
              // Found a DMT tab, close it.
              thisBrowser.selectedTab = thisBrowser.visibleTabs[index];
              BrowserCloseTabOrWindow();
            }
          }
        } catch (e) {
        }

        // Restore selected tab if it wasn't DMT. If it was DMT then just let
        // the browser decide which window to select.
        if (oldTab != null)
          thisBrowser.selectedTab = oldTab;
      }
    }

    // Close Download Manager in a separate window
    dmtBrowserOverlay.dmtWindowClose(0);
  },

  ////////////////////////////////////////////////////////////////////////////////
  // When download window is opened there are several complications.
  // 1) The user may have selected to open after a delay. This can be scheduled
  //    for that to happen.
  // 2) The user may have selected when download is complete and download happened
  //    so fast that it beat the window opening (especially if open is after a
  //    delay). In this case don't open the window at all.
  // 3) The open in dmtToggleDownloadMgr() may fail because it is called before
  //    the window has been activated. It is recalled after a delay to fix dmtBrowserOverlay.
  dmtDelayedOpenFirst: function DBO_dmtDelayedOpenFirst()
  {
    // This was called from dmtDownloadObserver. Don't show if download finished
    // before the user specified delay. Always show if the delay was 0.
    var delay = dmtBrowserOverlay.dmtPrefBranch.getIntPref("browser.download.manager.openDelay");
    if ((delay == 0) || (dmtBrowserOverlay.activeDownloadCount() > 0))
//    if (dmtBrowserOverlay.activeDownloadCount() > 0)
    {
//  alert("dmtStart 0");
      if (dmtBrowserOverlay.dmtToggleDownloadMgr(true, false))
        // This is case three: recall after a delay.
        TimerDmt.setTimeout(dmtBrowserOverlay.dmtDelayedOpenSecond, 500);
    }
  },

  ////////////////////////////////////////////////////////////////////////////////
  // Sometimes dmtDelayedOpenFirst() can fail because it is called before the
  // window has been activated. This allows the open to be retried after a delay.
  dmtDelayedOpenSecond: function DBO_dmtDelayedOpenSecond()
  {
    // This is called if dmtDelayedOpenFirst() failed and needs to be retried
    // after a delay. If a download is active then show no matter what, otherwise
    // more work is needed.
    var delay = dmtBrowserOverlay.dmtPrefBranch.getIntPref("browser.download.manager.openDelay");
    if ((delay == 0) || (dmtBrowserOverlay.activeDownloadCount() > 0))
//    if (dmtBrowserOverlay.activeDownloadCount() > 0)
    {
      dmtBrowserOverlay.dmtToggleDownloadMgr(true, false);
    }
    else
    {
      // The download finished between the first call and this recursive call.
      // If set to close when download completes then don't show at all, but
      // if not then show it even if no download is active, because it finished
      // after the user specified delay.
      try {
        // Force the original download manager preference off and use the new
        // DMT one. The DMT one handles tab and sidebar as well as the window.
        // The original is used in the C++ code and can't be overridden by
        // javascipt code.
        dmtBrowserOverlay.dmtPrefBranch.setBoolPref("browser.download.manager.closeWhenDone", false);
        var close = dmtBrowserOverlay.dmtPrefBranch.getBoolPref("extensions.downloadmgr.closeWhenDone");
      } catch (e) {close = false;}
      if (!close)
        dmtBrowserOverlay.dmtToggleDownloadMgr(true, false);
    }
  },


  ////////////////////////////////////////////////////////////////////////////////
  //
  activeDownloadCount: function DBO_activeDownloadCount()
  {
    var activeCount = 0;
    var downloadsList = null;

    //dmtBrowserOverlay.dmtList.then(list => list.getAll().then(_dls => {downloadsList = _dls}));
    //dmtBrowserOverlay.dmtList.then(list => downloadsList = list._downloads);
    downloadsList = Downloads._lists[Downloads.ALL]._downloads;

    if (downloadsList)
    {
      for (let download of downloadsList)
      {
//        if ((download.progress < 100) || (!download.hasProgress))
        if (!download.stopped)
          activeCount++;
      }
    }

    return activeCount;
  },


  ////////////////////////////////////////////////////////////////////////////////
  // Formerly part of the DMT-dl-start notify handler.
  dmtOpenHandler: function DBO_dmtOpenHandler(download)
  {
//    console.log("Added " + download.target.path);
    //if ((!download.stopped) && (this.currentBytes == 0) && (!this.hasProgress))
//    if (!download.stopped)
    if (!download.dmtAdded)
    {
      download.dmtAdded = true;
      try {
        // Force the original download manager preference off and use the new
        // DMT one. The DMT one handles tab and sidebar as well as the window.
        // The original is used in the C++ code and can't be overridden by
        // javascipt code.
//        dmtBrowserOverlay.dmtPrefBranch.setBoolPref("browser.download.manager.showWhenStarting", false);
        var show = dmtBrowserOverlay.dmtPrefBranch.getBoolPref("extensions.downloadmgr.showWhenStarting");
        var delay = dmtBrowserOverlay.dmtPrefBranch.getIntPref("browser.download.manager.openDelay");
      } catch (e) {show = false;}
    //alert("dmtStart 2");
      if (show)
      {
//  alert("dmtStart 3");
        if (delay == 0)
          dmtBrowserOverlay.dmtDelayedOpenFirst();
        else
          TimerDmt.setTimeout(dmtBrowserOverlay.dmtDelayedOpenFirst, delay);
      }
    }
  },


  ////////////////////////////////////////////////////////////////////////////////
  // Class to handle notifications from nsIObserverService
  dmtDownloadObserver: {
    observe: function (aSubject, aTopic, aState)
    {
      switch (aTopic) {
  //    case "DMT-dl-start":
  //      try {
  //        // Force the original download manager preference off and use the new
  //        // DMT one. The DMT one handles tab and sidebar as well as the window.
  //        // The original is used in the C++ code and can't be overridden by
  //        // javascipt code.
  //        dmtBrowserOverlay.dmtPrefBranch.setBoolPref("browser.download.manager.showWhenStarting", false);
  //        var show = dmtBrowserOverlay.dmtPrefBranch.getBoolPref("extensions.downloadmgr.showWhenStarting");
  //        var delay = dmtBrowserOverlay.dmtPrefBranch.getIntPref("browser.download.manager.openDelay");
  //      } catch (e) {show = false;}
  ////alert("dmtStart 2");
  //      if (show)
  //      {
  //        if (delay == 0)
  //          dmtBrowserOverlay.dmtDelayedOpenFirst();
  //        else
  //          TimerDmt.setTimeout(dmtBrowserOverlay.dmtDelayedOpenFirst, delay);
  //      }
  //      break;

  //    case "DMT-dl-failed":
  //    case "DMT-dl-cancel":
  //      break;

      case "DMT-dl-done":
        try {
          // Force the original download manager preference off and use the new
          // DMT one. The DMT one handles tab and sidebar as well as the window.
          // The original is used in the C++ code and can't be overridden by
          // javascipt code.
          dmtBrowserOverlay.dmtPrefBranch.setBoolPref("browser.download.manager.closeWhenDone", false);
          var close = dmtBrowserOverlay.dmtPrefBranch.getBoolPref("extensions.downloadmgr.closeWhenDone");
        } catch (e) {close = false;}

        if (close && (dmtBrowserOverlay.activeDownloadCount() == 0))
          dmtBrowserOverlay.dmtAutoClose();
        break;

      case "DMT-ui-close":
        dmtBrowserOverlay.dmtCloseDownloadMgr();
        break;

      case "DMT-ui-escape":
        dmtBrowserOverlay.dmtEscapeDownloadMgr();
        break;
      }
    }
  },

  ////////////////////////////////////////////////////////////////////////////////
  // Called at Firefox startup. Sets up observers other one time initialization.
  dmtInit: function DBO_dmtInit()
  {
    // Only ever call once
    window.removeEventListener("load", dmtBrowserOverlay.dmtInit, true);

  // This was a failed attempt to fix problem of download complete notify box
  // where clicking does not open tab or sidebar, but window.
  //  var dmUI = Components.classes["@mozilla.org/download-manager-ui;1"].
  //      getService(Components.interfaces.nsIDownloadManagerUI);
  //  alert("dmUI = " + dmUI);
  //  alert("dmUI.show = " + dmUI.show);
  //  dmUI.show = dmtBrowserOverlay.dmtToggleDownloadMgr;
  //  alert("dmUI.show = " + dmUI.show);

    var winType = 0;
    try {
      winType = dmtBrowserOverlay.dmtPrefBranch.getIntPref("extensions.downloadmgr.windowType");
    } catch (e) {}

    try {
      if (winType == 1)
        document.getElementById("downloads-button").observes = "viewDmtSidebar";
      else
        document.getElementById("downloads-button").observes = "Tools:Downloads";
      //DownloadsCommon.__defineGetter__("useToolkitUI", function(){return true;});
    } catch (e) {}

    // Handlers for events generated by the Download Manager (download events)
    var observerService = Components.classes["@mozilla.org/observer-service;1"].
                          getService(Components.interfaces.nsIObserverService);
  //  observerService.addObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-dl-start",      false);
  //  observerService.addObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-dl-failed",     false);
  //  observerService.addObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-dl-cancel",     false);
    observerService.addObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-dl-done",       false);
    observerService.addObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-ui-close",  false);
    observerService.addObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-ui-escape", false);

    // Catch events from new download manager and turn them in events like the
    // ones used by old download manager. Will clean this up later.
    dmtBrowserOverlay.dmtList = Downloads.getList(Downloads.ALL);
    dmtBrowserOverlay.dmtView = {
  //    onDownloadAdded:   download => observerService.notifyObservers(null, "DMT-dl-start", null),
      onDownloadAdded:   download => dmtBrowserOverlay.dmtOpenHandler(download),
      onDownloadChanged: download => {if (download.stopped) observerService.notifyObservers(null, "DMT-dl-done", null);},
      canRemoveFinished: download => observerService.notifyObservers(null, "DMT-dl-done", null),
    };

    dmtBrowserOverlay.dmtList.then(obj => obj.addView(dmtBrowserOverlay.dmtView));

    // Force some existing preferences off. DMT has it's own, which handle tab and
    // sidebar as well as the window.
    try {
      dmtBrowserOverlay.dmtPrefBranch.setBoolPref("browser.download.manager.showWhenStarting", false);
      dmtBrowserOverlay.dmtPrefBranch.setBoolPref("browser.download.manager.closeWhenDone", false);
    } catch (e) {}
  },

  ////////////////////////////////////////////////////////////////////////////////
  // Cleans up observers when Firefox exits. Does not appear to be called.
  // Pointless to cleanup if Firefox is exiting anyway.
  dmtExit: function DBO_dmtExit(aEvent)
  {
    var observerService = Components.classes["@mozilla.org/observer-service;1"].
                          getService(Components.interfaces.nsIObserverService);

    // Disconnect
//    dmtBrowserOverlay.dmtList.then(obj => obj.removeView(dmtBrowserOverlay.dmtView));
    Downloads._lists[Downloads.ALL].removeView(dmtBrowserOverlay.dmtView);

    observerService.removeObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-ui-escape");
    observerService.removeObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-ui-close");
    observerService.removeObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-dl-done");
  //  observerService.removeObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-dl-cancel");
  //  observerService.removeObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-dl-failed");
  //  observerService.removeObserver(dmtBrowserOverlay.dmtDownloadObserver, "DMT-dl-start");
  }

}

window.addEventListener("load", dmtBrowserOverlay.dmtInit, true);

////////////////////////////////////////////////////////////////////////////////
// This overwrites the function in browser.js. It opens the download manager
// if someone calls it, instead of using the "Tools:Downloads" command.
function BrowserDownloadsUI()
{
  dmtBrowserOverlay.dmtToggleDownloadMgr(true, true);
}

